## lizardfs 2.5.4.2+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_MODULE_PATH})

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR
    "In-source builds are disabled for this project. This is for your "
    "safety. To build the project, please create a build tree in "
    "a separate directory, for example:\n"
    "     mkdir ${CMAKE_SOURCE_DIR}/build\n"
    "     cd ${CMAKE_SOURCE_DIR}/build\n"
    "     cmake ..\n"
    "Before doing that you may need to clean up after this try by removing "
    "CMakeCache.txt file and CMakeFiles/ directory.\n"
    "If you REALLY need an in-source build, remove this check from "
    "${CMAKE_CURRENT_LIST_FILE} and try again."
  )
endif()

project(lizardfs)
set(PACKAGE_VERSION_MAJOR 2)
set(PACKAGE_VERSION_MINOR 5)
set(PACKAGE_VERSION_MICRO 4)
set(PACKAGE_VERSION
    "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_MICRO}")

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug)
endif()

set(CXX_STD c++0x)
if(CYGWIN)
  set(CXX_STD gnu++11)
endif()
set(CMAKE_CXX_FLAGS "-pipe -std=${CXX_STD} -pthread -Wall -Wextra -fwrapv")
set(CMAKE_CXX_FLAGS_DEBUG "-O0 -g")
set(CMAKE_CXX_FLAGS_RELEASE "-O3 -DNDEBUG -g")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O2 -DNDEBUG -g -fno-omit-frame-pointer")
set(CMAKE_CXX_FLAGS_COVERAGE "-O0 -g --coverage")
set(CMAKE_CXX_FLAGS_CLANG_ANALYZE "--analyze -Xanalyzer -analyzer-output=text")
set(CMAKE_CXX_FLAGS_CLANG_SANITIZE_THREAD "-g -O0 -fsanitize=thread")

add_definitions(-D_LARGEFILE_SOURCE)
add_definitions(-D_FILE_OFFSET_BITS=64)
add_definitions(-DLIZARDFS_HAVE_CONFIG_H)
add_definitions(-D__STDC_LIMIT_MACROS)
add_definitions(-D__STDC_CONSTANT_MACROS)
add_definitions(-D__STDC_FORMAT_MACROS)

# XXX(lamvak): what about OS X?
set(DEFAULT_USER  "mfs" CACHE STRING "Default user to run daemons as")
set(DEFAULT_GROUP "mfs" CACHE STRING "Default group to run daemons as")
option(ENABLE_WERROR        "Enable treating compilation warnings as errors"          OFF)
option(ENABLE_LIGHTMFS      "Enable light version of LizardFS"                        OFF)
option(ENABLE_DEBIAN_PATHS  "Enable Debian-style install paths"                       OFF)
option(ENABLE_UTILS         "Enable building additional binaries used e.g. in tests"  OFF)
option(ENABLE_TESTS         "Enable building unit and functional tests"               OFF)
option(ENABLE_DOCS          "Enable building the documentation"                       ON)
option(ENABLE_EXIT_ON_USR1  "Enable handler for SIGUSR1 which calls exit()"           OFF)
option(THROW_INSTEAD_OF_ABORT   "Throw std::exception instead of calling abort"       OFF)
option(ENABLE_DEBUG_LOG     "Enable prefix based debug logs"                          OFF)
# end of LizardFS options

message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "DEFAULT_USER: ${DEFAULT_USER}")
message(STATUS "DEFAULT_GROUP: ${DEFAULT_GROUP}")
message(STATUS "ENABLE_WERROR: ${ENABLE_WERROR}")
message(STATUS "ENABLE_LIGHTMFS: ${ENABLE_LIGHTMFS}")
message(STATUS "ENABLE_DEBIAN_PATHS: ${ENABLE_DEBIAN_PATHS}")
message(STATUS "ENABLE_UTILS: ${ENABLE_UTILS}")
message(STATUS "ENABLE_TESTS: ${ENABLE_TESTS}")
message(STATUS "ENABLE_DOCS: ${ENABLE_DOCS}")
message(STATUS "ENABLE_EXIT_ON_USR1: ${ENABLE_EXIT_ON_USR1}")
message(STATUS "THROW_INSTEAD_OF_ABORT: ${THROW_INSTEAD_OF_ABORT}")
message(STATUS "ENABLE_DEBUG_LOG: ${ENABLE_DEBUG_LOG}")
# end of LizardFS options values

# All the environment tests (libs, includes, etc.) live here:
include(EnvTests.cmake)
include(Libraries)
check_includes("${INCLUDES}")

# Disable -pedantic for old gcc because of unfounded
# "no comma at end of enumerator list" warning during crcutil compilation
execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE COMPILER_VERSION)
if(ENABLE_WERROR AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND COMPILER_VERSION VERSION_LESS 4.7)
  message(STATUS "Flag '-pedantic' disabled for GCC < 4.7")
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic")
endif()

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qunused-arguments")
endif()

if(CXX_HAS_WNOGNU)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-gnu")
endif()

if(ENABLE_WERROR)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

if(ENABLE_TESTS AND NOT THROW_INSTEAD_OF_ABORT)
  message(STATUS "Tests require THROW_INSTEAD_OF_ABORT to be set to YES, changing passed value:")
    set(THROW_INSTEAD_OF_ABORT YES)
  message(STATUS "THROW_INSTEAD_OF_ABORT: ${THROW_INSTEAD_OF_ABORT}")
endif()

if(ENABLE_DEBIAN_PATHS)
  if (NOT CMAKE_INSTALL_PREFIX STREQUAL "/")
    message(WARNING "Debian paths enabled, but CMAKE_INSTALL_PREFIX is different than /")
  endif()
  set(BIN_SUBDIR   "usr/bin")
  set(SBIN_SUBDIR  "usr/sbin")
  set(ETC_SUBDIR   "etc")
  set(RUN_SUBDIR   "var/run/mfs")
  set(DATA_SUBDIR  "var/lib/mfs")
  set(MAN_SUBDIR   "usr/share/man")
  set(CGI_SUBDIR   "usr/share/mfscgi")
else()
  set(BIN_SUBDIR   "bin")
  set(SBIN_SUBDIR  "sbin")
  set(ETC_SUBDIR   "etc")
  set(RUN_SUBDIR   "var/run/mfs")
  set(DATA_SUBDIR  "var/lib/mfs")
  set(MAN_SUBDIR   "share/man")
  set(CGI_SUBDIR   "share/mfscgi")
endif()
set(BIN_PATH   ${CMAKE_INSTALL_PREFIX}/${BIN_SUBDIR})
set(SBIN_PATH  ${CMAKE_INSTALL_PREFIX}/${SBIN_SUBDIR})
set(ETC_PATH   ${CMAKE_INSTALL_PREFIX}/${ETC_SUBDIR})
set(RUN_PATH   ${CMAKE_INSTALL_PREFIX}/${RUN_SUBDIR})
set(DATA_PATH  ${CMAKE_INSTALL_PREFIX}/${DATA_SUBDIR})
set(MAN_PATH   ${CMAKE_INSTALL_PREFIX}/${MAN_SUBDIR})
set(CGI_PATH   ${CMAKE_INSTALL_PREFIX}/${CGI_SUBDIR})

if(ENABLE_LIGHTMFS)
  set(PROTO_BASE 65536)
  set(LIGHT_MFS 1)
else()
  set(PROTO_BASE 0)
  set(LIGHT_MFS 0)
endif()

if(ENABLE_TESTS)
  set(BUILD_TESTS ON)
  set(BUILD_UTILS ON)
  set(LIZARDFS_ENABLE_DEBUG_LOG ON)
endif()

if(ENABLE_DEBUG_LOG)
  set(LIZARDFS_ENABLE_DEBUG_LOG ON)
endif()

set(CHARTS_CSV_CHARTID_BASE 90000)

if(THROW_INSTEAD_OF_ABORT)
  add_definitions(-DTHROW_INSTEAD_OF_ABORT)
endif()


# Create config.h file
set(DATA_PATH "${CMAKE_INSTALL_PREFIX}/${DATA_SUBDIR}")
set(ETC_PATH "${CMAKE_INSTALL_PREFIX}/${ETC_SUBDIR}")
set(RUN_PATH "${CMAKE_INSTALL_PREFIX}/${RUN_SUBDIR}")
configure_file(config.h.in config.h)
include_directories(${CMAKE_BINARY_DIR}) # Here we have generated config.h

# main.cc shared by some LizardFS applications
set(MAIN_SRC ${CMAKE_SOURCE_DIR}/src/main/main.cc)

# functions & macros
macro(collect_sources VAR_PREFIX)
  file(GLOB ${VAR_PREFIX}_TESTS *_unittest.cc)
  file(GLOB ${VAR_PREFIX}_SOURCES *.cc *.h)
  file(GLOB ${VAR_PREFIX}_MAIN main.cc)
  if(${VAR_PREFIX}_MAIN OR ${VAR_PREFIX}_TESTS)
    list(REMOVE_ITEM ${VAR_PREFIX}_SOURCES ${${VAR_PREFIX}_TESTS} ${${VAR_PREFIX}_MAIN})
  endif()
endmacro(collect_sources)

function(add_tests TESTED_LIBRARY)
  if(NOT BUILD_TESTS OR ARGC EQUAL 1)
    return()
  endif()
  list(REMOVE_AT ARGV 0)
  set(TEST_LIBRARY_NAME ${TESTED_LIBRARY}_tests)
  include_directories(${GTEST_INCLUDE_DIRS})
  add_library(${TEST_LIBRARY_NAME} ${ARGV})
  target_link_libraries(${TEST_LIBRARY_NAME} ${TESTED_LIBRARY})
  set(TMP ${TEST_LIBRARIES})
  list(APPEND TMP ${TEST_LIBRARY_NAME})
  set(TEST_LIBRARIES ${TMP} CACHE INTERNAL "" FORCE)
endfunction(add_tests)

if(ZLIB_FOUND)
  include_directories(${ZLIB_INCLUDE_DIRS})
endif()
include_directories(src) # Allow paths relative to src, eg. #include common/crc.h
add_subdirectory(external)
add_subdirectory(src/common)
add_subdirectory(src/chunkserver)
add_subdirectory(src/master)
add_subdirectory(src/metadump)
add_subdirectory(src/metalogger)
add_subdirectory(src/metarestore)
add_subdirectory(src/probe)
add_subdirectory(src/tools)
add_subdirectory(src/mount)
if (FUSE_LIBRARY)
  add_subdirectory(src/mount/fuse)
endif()
add_subdirectory(src/mount/polonaise)
add_subdirectory(src/data)
add_subdirectory(src/cgi)
if(BUILD_UTILS)
  add_subdirectory(utils)
endif()
if(BUILD_TESTS)
  add_subdirectory(src/unittests)
  add_subdirectory(tests)
endif()
if(ENABLE_DOCS)
  add_subdirectory(doc)
endif()

include(Packages.cmake)

=== doc/CMakeLists.txt ===
if(NOT A2X_BINARY)
  message(WARNING "Program 'a2x' not found, manpages won't be generated")
  return()
endif()

# These manpages should be generated
set(MANPAGES
    lizardfs.7          # not a source
    lizardfs-probe.8
    mfsappendchunks.1
    mfscheckfile.1
    mfsdirinfo.1
    mfsfileinfo.1
    mfsfilerepair.1
    mfsgeteattr.1
    mfsseteattr.1       # not a source
    mfsdeleattr.1       # not a source
    mfsgetgoal.1
    mfssetgoal.1        # not a source
    mfsrgetgoal.1       # not a source
    mfsrsetgoal.1       # not a source
    mfsgettrashtime.1
    mfssettrashtime.1   # not a source
    mfsrgettrashtime.1  # not a source
    mfsrsettrashtime.1  # not a source
    mfsmakesnapshot.1
    mfsmount.1
    mfsrepquota.1
    mfssetquota.1       # not a source
    mfstools.1
    globaliolimits.cfg.5
    iolimits.cfg.5
    mfschunkserver.cfg.5
    mfsexports.cfg.5
    mfsgoals.cfg.5
    mfshdd.cfg.5
    mfsmaster.cfg.5
    mfsmetalogger.cfg.5
    mfstopology.cfg.5
    moosefs.7
    mfs.7               # not a source
    mfscgiserv.8
    mfschunkserver.8
    mfsmaster.8
    mfsmetalogger.8
    mfsmetarestore.8
)

set(INSTALLED_MANPAGES)
foreach(MANPAGE ${MANPAGES})
  get_filename_component(MANPAGE_SRC ${CMAKE_CURRENT_SOURCE_DIR}/${MANPAGE}.txt ABSOLUTE)
  string(REGEX MATCH "[0-9]$" SECTION_NUMBER ${MANPAGE})
  set(GENERATED_MANPAGE_PATH ${CMAKE_CURRENT_BINARY_DIR}/${MANPAGE})
  if(EXISTS ${MANPAGE_SRC})
    # Generate from the source...
    set(MANPAGE_SRC_SYMLINK ${CMAKE_CURRENT_BINARY_DIR}/${MANPAGE}.txt)
    add_custom_command(OUTPUT ${GENERATED_MANPAGE_PATH}
        COMMAND ln -s -f ${MANPAGE_SRC} ${MANPAGE_SRC_SYMLINK}
        COMMAND a2x -f manpage ${MANPAGE_SRC_SYMLINK}
        DEPENDS ${MANPAGE_SRC})
    # Add this file to the main target's dependencies
    set(GENERATED_MANPAGES ${GENERATED_MANPAGES} ${GENERATED_MANPAGE_PATH})
  endif()
  # Install the generated file
  install(FILES ${GENERATED_MANPAGE_PATH} DESTINATION ${MAN_SUBDIR}/man${SECTION_NUMBER})
endforeach()
add_custom_target(manpages ALL SOURCES ${GENERATED_MANPAGES})

=== utils/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR})

install(PROGRAMS cpp-interpreter.sh DESTINATION ${BIN_SUBDIR})

# test files generator
add_executable(file-generate file_generate.cc)
install(TARGETS file-generate RUNTIME DESTINATION ${BIN_SUBDIR})

# test files generator which overwrites existing files
add_executable(file-overwrite file_overwrite.cc)
install(TARGETS file-overwrite RUNTIME DESTINATION ${BIN_SUBDIR})

# test files validator
add_executable(file-validate file_validate.cc)
install(TARGETS file-validate RUNTIME DESTINATION ${BIN_SUBDIR})

=== src/cgi/CMakeLists.txt ===
configure_file(cgiserv.py.in   mfscgiserv.py)
configure_file(chart.cgi.in    chart.cgi)
configure_file(mfs.cgi.in      mfs.cgi)

set(CGI_FILES err.gif favicon.ico index.html logomini.png mfs.css)
set(CGI_SCRIPTS
    ${CMAKE_CURRENT_BINARY_DIR}/mfs.cgi
    ${CMAKE_CURRENT_BINARY_DIR}/chart.cgi)
set(CGI_SERVER
    ${CMAKE_CURRENT_BINARY_DIR}/mfscgiserv.py)

install(FILES ${CGI_FILES} DESTINATION ${CGI_SUBDIR})
install(PROGRAMS ${CGI_SCRIPTS} DESTINATION ${CGI_SUBDIR})
install(PROGRAMS ${CGI_SERVER} DESTINATION ${SBIN_SUBDIR} RENAME mfscgiserv)

=== src/master/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_definitions(-DAPPNAME=mfsmaster)

collect_sources(MASTER)

add_library(master ${MASTER_SOURCES})
target_link_libraries(master mfscommon)
add_tests(master ${MASTER_TESTS})

set(RESTORE_SRC ${CMAKE_SOURCE_DIR}/src/metarestore/restore.cc)
set(METALOGGER_SRC ${CMAKE_SOURCE_DIR}/src/metalogger/masterconn.cc)
add_executable(mfsmaster ${MAIN_SRC} ${RESTORE_SRC} ${METALOGGER_SRC})
target_link_libraries(mfsmaster master)
install(TARGETS mfsmaster RUNTIME DESTINATION ${SBIN_SUBDIR})

configure_file(mfsrestoremaster.in mfsrestoremaster @ONLY)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/mfsrestoremaster DESTINATION ${SBIN_SUBDIR})

=== src/metalogger/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_definitions(-DMETALOGGER)
add_definitions(-DAPPNAME=mfsmetalogger)

collect_sources(METALOGGER)

add_library(metalogger ${METALOGGER_SOURCES})
target_link_libraries(metalogger mfscommon)
target_link_libraries(metalogger)
add_tests(metalogger ${METALOGGER_TESTS})

add_executable(mfsmetalogger ${MAIN_SRC})
target_link_libraries(mfsmetalogger metalogger)
install(TARGETS mfsmetalogger RUNTIME DESTINATION ${SBIN_SUBDIR})

=== src/metarestore/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR} ../master)
add_definitions(-DMETARESTORE)
add_definitions(-DAPPNAME=mfsmetarestore)

collect_sources(METARESTORE)

add_library(metarestore ${METARESTORE_SOURCES} ../master/filesystem.cc ../master/chunks.cc ../master/quota_database.cc ../master/chunk_goal_counters.cc)
target_link_libraries(metarestore mfscommon)
target_link_libraries(metarestore)
add_tests(metarestore ${METARESTORE_TESTS})

add_executable(mfsmetarestore ${METARESTORE_MAIN})
target_link_libraries(mfsmetarestore metarestore)
target_link_libraries(mfsmetarestore mfscommon)
target_link_libraries(mfsmetarestore)
install(TARGETS mfsmetarestore RUNTIME DESTINATION ${SBIN_SUBDIR})

=== src/probe/CMakeLists.txt ===
collect_sources(LIZARDFS_PROBE)

add_library(lizardfs-probe-lib ${LIZARDFS_PROBE_SOURCES})
target_link_libraries(lizardfs-probe-lib mfscommon)
add_tests(lizardfs-probe-lib ${LIZARDFS_PROBE_TESTS})

add_executable(lizardfs-probe ${LIZARDFS_PROBE_MAIN})
target_link_libraries(lizardfs-probe lizardfs-probe-lib)
install(TARGETS lizardfs-probe RUNTIME DESTINATION ${BIN_SUBDIR})

=== src/unittests/CMakeLists.txt ===
include_directories(${GTEST_INCLUDE_DIRS})
include_directories(../common)

add_executable(unittests main.cc)
target_link_libraries(unittests gtest mfscommon
    "-Wl,--whole-archive" ${TEST_LIBRARIES} "-Wl,--no-whole-archive")

=== debian/changelog ===
lizardfs (2.5.4.2+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #619841).

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 26 Mar 2015 09:59:22 +1100

=== debian/control ===
Source: lizardfs
Section: admin
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper (>= 9), dh-python, dh-systemd
              ,python-all
              ,cmake
              ,asciidoc
                  ,libxml2-utils
                  ,docbook-xml
                  ,docbook-xsl
                  ,xsltproc
              ,pkg-config
#             ,libboost-all-dev
# libcrcutil is for little-endian architectures only.
              ,libcrcutil-dev [!hppa !m68k !mips !powerpc !powerpcspe !ppc64 !s390 !s390x !sparc !sparc64]
              ,libfuse-dev
              ,libgtest-dev
              ,zlib1g-dev
Standards-Version: 3.9.6
X-Python-Version: >= 2.7 << 3.0
Homepage: http://lizardfs.org/
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/lizardfs.git
Vcs-Git: git://anonscm.debian.org/collab-maint/lizardfs.git

Package: lizardfs-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
        ,adduser
Description: LizardFS - common files
 Files and services common for all LizardFS daemons.
 .
 LizardFS is a reliable, scalable and efficent distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-master
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
        ,lizardfs-common (>= ${source:Version})
Description: LizardFS - master server
 LizardFS master (metadata) server.
 .
 LizardFS is a reliable, scalable and efficent distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-metalogger
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
        ,lizardfs-common (>= ${source:Version})
Description: LizardFS - metalogger server
 LizardFS metadata replication (backup) server.
 .
 LizardFS is a reliable, scalable and efficent distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-chunkserver
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
        ,lizardfs-common (>= ${source:Version})
Description: LizardFS - data server
 The LizardFS data server.
 .
 LizardFS is a reliable, scalable and efficent distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-client
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: LizardFS - client tools and mount utility
 LizardFS FUSE mount utility "mfsmount" and client tool "mfstools".
 .
 LizardFS is a reliable, scalable and efficent distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-adm
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: LizardFS - administration tools
 LizardFS administration tool: lizardfs-probe
 .
 LizardFS is a reliable, scalable and efficent distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-cgi
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
        ,python
Description: LizardFS - CGI monitor
 CGI application to monitor LizardFS through master/metadata server.
 .
 LizardFS is a reliable, scalable and efficent distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-cgiserv
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
        ,lizardfs-cgi
        ,lizardfs-common (>= ${source:Version})
        ,${python:Depends}
Description: simple CGI-capable HTTP server to run LizardFS CGI monitor
 Simple standalone CGI-capable HTTP server to run LizardFS CGI Monitor.
 .
 LizardFS is a reliable, scalable and efficent distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends}
        ,lizardfs-master (= ${binary:Version}) | lizardfs-metalogger (= ${binary:Version}) | lizardfs-chunkserver (= ${binary:Version})
Description: Debugging symbols for LizardFS
 Debugging symbols for all LizardFS binaries
 .
 LizardFS is a reliable, scalable and efficent distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

#Package: lizardfs-tests
#Built-Using: ${my:Built-Using}
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends}
#        ,lizardfs-common (>= ${source:Version})
#        ,lizardfs-chunkserver (>= ${source:Version})
#        ,lizardfs-master (>= ${source:Version})
#        ,lizardfs-client (>= ${source:Version})
#        ,lizardfs-adm (>= ${source:Version})
#        ,attr
#        ,dbench
#        ,fuse
#        ,netcat-openbsd
#        ,socat
#        ,sudo
#        ,valgrind
#Description: LizardFS - tests suite
# The LizardFS test suite.
# .
# LizardFS is a reliable, scalable and efficent distributed file system. It
# spreads data over a number of physical servers, making it visible to an
# end user as a single file system.
# .
# Functions such as data replication, checksums, instant snapshots and easy
# connection of additional servers make LizardFS a perfect solution for
# users who need fault-proof storage ready for future expansion.
# LizardFS features include:
#  * High availbility.
#  * Quotas.
#  * POSIX Access Control Lists and POSIX Extended Attributes.
#  * I/O bandwidth limiting.
# .
# LizardFS can be used whenever one needs to store large quantities of data
# in a secure way and process them swiftly.
# LizardFS is a fork of MooseFS.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

## fix FTBFS@ppc64: https://github.com/lizardfs/lizardfs/issues/249
ifneq (,$(filter $(DEB_HOST_ARCH),powerpc powerpcspe))
DEB_LDFLAGS_MAINT_APPEND = -latomic
endif

# minimise needless linking
export DEB_LDFLAGS_MAINT_APPEND += -Wl,--as-needed

## Build tests only on amd64, see https://github.com/lizardfs/lizardfs/issues/197
ifeq ($(DEB_HOST_ARCH),amd64)
OPTARGS = -DENABLE_TESTS=YES
endif

%:
	dh $@ --buildsystem=cmake --builddirectory=build --parallel --with systemd,python2

override_dh_auto_clean:
	$(RM) -rv external/gtest
	dh_auto_clean

override_dh_auto_configure:
	## copy gtest sources
	cp -Rv /usr/src/gtest external/
	dh_auto_configure -- $(OPTARGS)    \
               -DCMAKE_VERBOSE_MAKEFILE=ON \
               -DCMAKE_BUILD_TYPE=Release  \
               -DCMAKE_INSTALL_PREFIX=""   \
               -DENABLE_DEBIAN_PATHS=YES   \
               -DENABLE_UTILS=YES

override_dh_auto_install:
	dh_auto_install
	## rename config files
	for i in debian/tmp/etc/mfs/*.cfg.dist; do \
	    mv -n -v "$$i" "$${i%%.dist}"          \
	;done

override_dh_python2:
	dh_python2
	dh_python2 /usr/share/mfscgi

override_dh_gencontrol:
	dh_gencontrol -- -Vmy:Built-Using="$(foreach pkg,libgtest-dev,$(word 2,$(shell dpkg --status $(pkg) | grep Source)) (=$(word 2,$(shell dpkg --status $(pkg) | grep Version))),)"

override_dh_compress:
	## See #781131
	dh_compress --exclude="examples/mfsexports.cfg" --exclude="examples/mfsmaster.cfg"

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_installinit:
	dh_installinit --no-start

override_dh_systemd_start:
	dh_systemd_start --no-start

override_dh_systemd_enable:
	dh_systemd_enable --no-enable

override_dh_strip:
	dh_strip --dbg-package=lizardfs-dbg

## lizardfs 2.6.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,8 +19,8 @@
 
 project(lizardfs)
 set(PACKAGE_VERSION_MAJOR 2)
-set(PACKAGE_VERSION_MINOR 5)
-set(PACKAGE_VERSION_MICRO 4)
+set(PACKAGE_VERSION_MINOR 6)
+set(PACKAGE_VERSION_MICRO 0)
 set(PACKAGE_VERSION
     "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_MICRO}")
 
@@ -32,10 +32,10 @@
 if(CYGWIN)
   set(CXX_STD gnu++11)
 endif()
-set(CMAKE_CXX_FLAGS "-pipe -std=${CXX_STD} -pthread -Wall -Wextra -fwrapv")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pipe -std=${CXX_STD} -pthread -Wall -Wextra -fwrapv")
 set(CMAKE_CXX_FLAGS_DEBUG "-O0 -g")
-set(CMAKE_CXX_FLAGS_RELEASE "-O3 -DNDEBUG -g")
-set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O2 -DNDEBUG -g -fno-omit-frame-pointer")
+set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -DNDEBUG -g")
+set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -O2 -DNDEBUG -g -fno-omit-frame-pointer")
 set(CMAKE_CXX_FLAGS_COVERAGE "-O0 -g --coverage")
 set(CMAKE_CXX_FLAGS_CLANG_ANALYZE "--analyze -Xanalyzer -analyzer-output=text")
 set(CMAKE_CXX_FLAGS_CLANG_SANITIZE_THREAD "-g -O0 -fsanitize=thread")
@@ -59,26 +59,31 @@
 option(ENABLE_EXIT_ON_USR1  "Enable handler for SIGUSR1 which calls exit()"           OFF)
 option(THROW_INSTEAD_OF_ABORT   "Throw std::exception instead of calling abort"       OFF)
 option(ENABLE_DEBUG_LOG     "Enable prefix based debug logs"                          OFF)
+option(ENABLE_HA_CLUSTER    "Enable installation of HA scripts"                       ON)
+option(ENABLE_VERBOSE_ASCIIDOC  "Enable verbose output of asciidoc"                   OFF)
 # end of LizardFS options
 
-message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
-message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
-message(STATUS "DEFAULT_USER: ${DEFAULT_USER}")
-message(STATUS "DEFAULT_GROUP: ${DEFAULT_GROUP}")
-message(STATUS "ENABLE_WERROR: ${ENABLE_WERROR}")
-message(STATUS "ENABLE_LIGHTMFS: ${ENABLE_LIGHTMFS}")
-message(STATUS "ENABLE_DEBIAN_PATHS: ${ENABLE_DEBIAN_PATHS}")
-message(STATUS "ENABLE_UTILS: ${ENABLE_UTILS}")
-message(STATUS "ENABLE_TESTS: ${ENABLE_TESTS}")
-message(STATUS "ENABLE_DOCS: ${ENABLE_DOCS}")
-message(STATUS "ENABLE_EXIT_ON_USR1: ${ENABLE_EXIT_ON_USR1}")
-message(STATUS "THROW_INSTEAD_OF_ABORT: ${THROW_INSTEAD_OF_ABORT}")
-message(STATUS "ENABLE_DEBUG_LOG: ${ENABLE_DEBUG_LOG}")
+message(STATUS "CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
+message(STATUS "CMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}")
+message(STATUS "DEFAULT_USER=${DEFAULT_USER}")
+message(STATUS "DEFAULT_GROUP=${DEFAULT_GROUP}")
+message(STATUS "ENABLE_WERROR=${ENABLE_WERROR}")
+message(STATUS "ENABLE_LIGHTMFS=${ENABLE_LIGHTMFS}")
+message(STATUS "ENABLE_DEBIAN_PATHS=${ENABLE_DEBIAN_PATHS}")
+message(STATUS "ENABLE_UTILS=${ENABLE_UTILS}")
+message(STATUS "ENABLE_TESTS=${ENABLE_TESTS}")
+message(STATUS "ENABLE_DOCS=${ENABLE_DOCS}")
+message(STATUS "ENABLE_EXIT_ON_USR1=${ENABLE_EXIT_ON_USR1}")
+message(STATUS "THROW_INSTEAD_OF_ABORT=${THROW_INSTEAD_OF_ABORT}")
+message(STATUS "ENABLE_DEBUG_LOG=${ENABLE_DEBUG_LOG}")
+message(STATUS "ENABLE_HA_CLUSTER=${ENABLE_HA_CLUSTER}")
+message(STATUS "ENABLE_VERBOSE_ASCIIDOC=${ENABLE_VERBOSE_ASCIIDOC}")
 # end of LizardFS options values
 
 # All the environment tests (libs, includes, etc.) live here:
 include(EnvTests.cmake)
 include(Libraries)
+include(GNUInstallDirs)
 check_includes("${INCLUDES}")
 
 # Disable -pedantic for old gcc because of unfounded
@@ -94,10 +99,6 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qunused-arguments")
 endif()
 
-if(CXX_HAS_WNOGNU)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-gnu")
-endif()
-
 if(ENABLE_WERROR)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
 endif()
@@ -105,7 +106,7 @@
 if(ENABLE_TESTS AND NOT THROW_INSTEAD_OF_ABORT)
   message(STATUS "Tests require THROW_INSTEAD_OF_ABORT to be set to YES, changing passed value:")
     set(THROW_INSTEAD_OF_ABORT YES)
-  message(STATUS "THROW_INSTEAD_OF_ABORT: ${THROW_INSTEAD_OF_ABORT}")
+  message(STATUS "THROW_INSTEAD_OF_ABORT=${THROW_INSTEAD_OF_ABORT}")
 endif()
 
 if(ENABLE_DEBIAN_PATHS)
@@ -114,27 +115,31 @@
   endif()
   set(BIN_SUBDIR   "usr/bin")
   set(SBIN_SUBDIR  "usr/sbin")
+  set(LIB_SUBDIR   "usr/lib")
   set(ETC_SUBDIR   "etc")
-  set(RUN_SUBDIR   "var/run/mfs")
   set(DATA_SUBDIR  "var/lib/mfs")
   set(MAN_SUBDIR   "usr/share/man")
   set(CGI_SUBDIR   "usr/share/mfscgi")
+  set(OCF_SUBDIR   "usr/lib/ocf/resource.d/lizardfs")
 else()
   set(BIN_SUBDIR   "bin")
   set(SBIN_SUBDIR  "sbin")
+  set(LIB_SUBDIR   "lib")
   set(ETC_SUBDIR   "etc")
-  set(RUN_SUBDIR   "var/run/mfs")
   set(DATA_SUBDIR  "var/lib/mfs")
   set(MAN_SUBDIR   "share/man")
   set(CGI_SUBDIR   "share/mfscgi")
-endif()
-set(BIN_PATH   ${CMAKE_INSTALL_PREFIX}/${BIN_SUBDIR})
-set(SBIN_PATH  ${CMAKE_INSTALL_PREFIX}/${SBIN_SUBDIR})
-set(ETC_PATH   ${CMAKE_INSTALL_PREFIX}/${ETC_SUBDIR})
-set(RUN_PATH   ${CMAKE_INSTALL_PREFIX}/${RUN_SUBDIR})
-set(DATA_PATH  ${CMAKE_INSTALL_PREFIX}/${DATA_SUBDIR})
-set(MAN_PATH   ${CMAKE_INSTALL_PREFIX}/${MAN_SUBDIR})
-set(CGI_PATH   ${CMAKE_INSTALL_PREFIX}/${CGI_SUBDIR})
+  set(OCF_SUBDIR   "lib/ocf/resource.d/lizardfs")
+endif()
+
+string(REGEX REPLACE "/$" "" INSTALL_PREFIX_NO_SLASH ${CMAKE_INSTALL_PREFIX})
+set(BIN_PATH   ${INSTALL_PREFIX_NO_SLASH}/${BIN_SUBDIR})
+set(SBIN_PATH  ${INSTALL_PREFIX_NO_SLASH}/${SBIN_SUBDIR})
+set(ETC_PATH   ${INSTALL_PREFIX_NO_SLASH}/${ETC_SUBDIR})
+set(DATA_PATH  ${INSTALL_PREFIX_NO_SLASH}/${DATA_SUBDIR})
+set(MAN_PATH   ${INSTALL_PREFIX_NO_SLASH}/${MAN_SUBDIR})
+set(CGI_PATH   ${INSTALL_PREFIX_NO_SLASH}/${CGI_SUBDIR})
+set(OCF_PATH   ${INSTALL_PREFIX_NO_SLASH}/${OCF_SUBDIR})
 
 if(ENABLE_LIGHTMFS)
   set(PROTO_BASE 65536)
@@ -162,9 +167,6 @@
 
 
 # Create config.h file
-set(DATA_PATH "${CMAKE_INSTALL_PREFIX}/${DATA_SUBDIR}")
-set(ETC_PATH "${CMAKE_INSTALL_PREFIX}/${ETC_SUBDIR}")
-set(RUN_PATH "${CMAKE_INSTALL_PREFIX}/${RUN_SUBDIR}")
 configure_file(config.h.in config.h)
 include_directories(${CMAKE_BINARY_DIR}) # Here we have generated config.h
 
@@ -200,13 +202,13 @@
 endif()
 include_directories(src) # Allow paths relative to src, eg. #include common/crc.h
 add_subdirectory(external)
+add_subdirectory(src/admin)
 add_subdirectory(src/common)
 add_subdirectory(src/chunkserver)
 add_subdirectory(src/master)
 add_subdirectory(src/metadump)
 add_subdirectory(src/metalogger)
 add_subdirectory(src/metarestore)
-add_subdirectory(src/probe)
 add_subdirectory(src/tools)
 add_subdirectory(src/mount)
 if (FUSE_LIBRARY)
@@ -225,5 +227,6 @@
 if(ENABLE_DOCS)
   add_subdirectory(doc)
 endif()
-
-include(Packages.cmake)
+if (ENABLE_HA_CLUSTER)
+  add_subdirectory(src/ha-cluster)
+endif()

=== external/CMakeLists.txt ===
# crcutil
include_directories(${CRCUTIL_INCLUDE_DIRS})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CRCUTIL_CXX_FLAGS}")
file(GLOB CRCUTIL_SOURCES ${CRCUTIL_SOURCE_DIR}/*.cc)
add_library(crcutil ${CRCUTIL_SOURCES})

# GoogleTest
if(BUILD_TESTS)
  include_directories(${GTEST_INCLUDE_DIRS})
  add_subdirectory(${GTEST_NAME})
endif()

=== utils/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,11 @@
 include_directories(${CMAKE_SOURCE_DIR})
 
 install(PROGRAMS cpp-interpreter.sh DESTINATION ${BIN_SUBDIR})
+
+# a library which causes pread/pwrite/close on chunks to return EIO
+add_library(chunk_operations_eio SHARED chunk_operations_eio.c)
+target_link_libraries(chunk_operations_eio dl)
+install(TARGETS chunk_operations_eio DESTINATION ${LIB_SUBDIR})
 
 # test files generator
 add_executable(file-generate file_generate.cc)

=== src/chunkserver/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_definitions(-DMFSMAXFILES=10000)
add_definitions(-DAPPNAME=mfschunkserver)

collect_sources(CHUNKSERVER)
add_library(chunkserver ${CHUNKSERVER_SOURCES})
target_link_libraries(chunkserver mfscommon)
add_tests(chunkserver ${CHUNKSERVER_TESTS})

add_executable(mfschunkserver ${MAIN_SRC})
target_link_libraries(mfschunkserver chunkserver)
install(TARGETS mfschunkserver RUNTIME DESTINATION ${SBIN_SUBDIR})

=== src/common/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

# Use crcutil Library
include_directories(${CRCUTIL_INCLUDE_DIRS})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CRCUTIL_CXX_FLAGS}")

collect_sources(COMMON)
add_library(mfscommon ${COMMON_SOURCES})
target_link_libraries(mfscommon crcutil)
if (ZLIB_FOUND)
  target_link_libraries(mfscommon ${ZLIB_LIBRARIES})
endif()
if (UNIX AND NOT APPLE)
  target_link_libraries(mfscommon ${RT_LIBRARY})
endif()
add_tests(mfscommon ${COMMON_TESTS})

=== src/data/CMakeLists.txt ===
configure_file(mfsmaster.cfg.in mfsmaster.cfg)
configure_file(mfschunkserver.cfg.in mfschunkserver.cfg)
configure_file(mfsmetalogger.cfg.in mfsmetalogger.cfg)
configure_file(postinst.in postinst)
set(POSTINST_SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/postinst PARENT_SCOPE)
install(FILES metadata.mfs DESTINATION ${DATA_SUBDIR} RENAME metadata.mfs.empty)
install(FILES mfsexports.cfg DESTINATION ${ETC_SUBDIR}/mfs RENAME mfsexports.cfg.dist)
install(FILES mfsgoals.cfg DESTINATION ${ETC_SUBDIR}/mfs RENAME mfsgoals.cfg.dist)
install(FILES mfshdd.cfg DESTINATION ${ETC_SUBDIR}/mfs RENAME mfshdd.cfg.dist)
install(FILES mfsmount.cfg DESTINATION ${ETC_SUBDIR}/mfs RENAME mfsmount.cfg.dist)
install(FILES mfstopology.cfg DESTINATION ${ETC_SUBDIR}/mfs RENAME mfstopology.cfg.dist)
install(FILES globaliolimits.cfg DESTINATION ${ETC_SUBDIR}/mfs RENAME globaliolimits.cfg.dist)
install(FILES iolimits.cfg DESTINATION ${ETC_SUBDIR}/mfs RENAME iolimits.cfg.dist)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mfsmaster.cfg DESTINATION ${ETC_SUBDIR}/mfs RENAME mfsmaster.cfg.dist)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mfschunkserver.cfg DESTINATION ${ETC_SUBDIR}/mfs RENAME mfschunkserver.cfg.dist)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mfsmetalogger.cfg DESTINATION ${ETC_SUBDIR}/mfs RENAME mfsmetalogger.cfg.dist)

=== src/ha-cluster/CMakeLists.txt ===
configure_file(metadataserver.in metadataserver @ONLY)
configure_file(lizardfs-cluster-manager.in lizardfs-cluster-manager @ONLY)

install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/metadataserver DESTINATION ${OCF_SUBDIR})
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/lizardfs-cluster-manager DESTINATION ${SBIN_SUBDIR})

=== src/master/CMakeLists.txt ===
--- 
+++ 
@@ -7,9 +7,7 @@
 target_link_libraries(master mfscommon)
 add_tests(master ${MASTER_TESTS})
 
-set(RESTORE_SRC ${CMAKE_SOURCE_DIR}/src/metarestore/restore.cc)
-set(METALOGGER_SRC ${CMAKE_SOURCE_DIR}/src/metalogger/masterconn.cc)
-add_executable(mfsmaster ${MAIN_SRC} ${RESTORE_SRC} ${METALOGGER_SRC})
+add_executable(mfsmaster ${MAIN_SRC})
 target_link_libraries(mfsmaster master)
 install(TARGETS mfsmaster RUNTIME DESTINATION ${SBIN_SUBDIR})

=== src/metalogger/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 collect_sources(METALOGGER)
 
-add_library(metalogger ${METALOGGER_SOURCES})
+add_library(metalogger ${METALOGGER_SOURCES} ../master/changelog.cc ../master/masterconn.cc)
 target_link_libraries(metalogger mfscommon)
 target_link_libraries(metalogger)
 add_tests(metalogger ${METALOGGER_TESTS})

=== src/metarestore/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 collect_sources(METARESTORE)
 
-add_library(metarestore ${METARESTORE_SOURCES} ../master/filesystem.cc ../master/chunks.cc ../master/quota_database.cc ../master/chunk_goal_counters.cc)
+add_library(metarestore ${METARESTORE_SOURCES} ../master/filesystem.cc ../master/chunks.cc ../master/quota_database.cc ../master/chunk_goal_counters.cc ../master/restore.cc)
 target_link_libraries(metarestore mfscommon)
 target_link_libraries(metarestore)
 add_tests(metarestore ${METARESTORE_TESTS})

=== src/mount/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

collect_sources(MOUNT)

add_library(mount ${MOUNT_SOURCES})
target_link_libraries(mount mfscommon)
add_tests(mount ${MOUNT_TESTS})

install(PROGRAMS mfssnapshot DESTINATION ${BIN_SUBDIR})

=== src/tools/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR} ../common)
set(MFSTOOL_LINKS
  mfsgetgoal
  mfssetgoal
  mfsgettrashtime
  mfssettrashtime
  mfscheckfile
  mfsfileinfo
  mfsappendchunks
  mfsdirinfo
  mfsfilerepair
  mfsmakesnapshot
  mfsgeteattr
  mfsseteattr
  mfsdeleattr
  mfsrgetgoal
  mfsrsetgoal
  mfsrgettrashtime
  mfsrsettrashtime
  mfssetquota
  mfsrepquota)

collect_sources(TOOLS)

add_executable(mfstools ${TOOLS_MAIN})
target_link_libraries(mfstools mfscommon)
install(TARGETS mfstools DESTINATION ${BIN_SUBDIR})

foreach(LINK ${MFSTOOL_LINKS})
  add_custom_target(${LINK} ALL
      COMMAND ln -sf mfstools ${LINK}
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      DEPENDS mfstools)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${LINK} DESTINATION ${BIN_SUBDIR})
endforeach()

=== debian/changelog ===
lizardfs (2.6.0+dfsg-1) unstable; urgency=low

  * New upstream release [May 2015].
  * Patchworks:
    - Dropped obsolete patches.
    + Replaced "man.patch" with "-DENABLE_VERBOSE_ASCIIDOC=ON".
    + Replaced "fadvise.patch" with "default-nocache.patch".
    + Added new "default-ignoregid.patch" to fix group permissions.
    + Added "upstream-rlimit.patch" to fix "mfsmount -o mfsmemlock".
      Thanks, Piotr Sarna.
    + Added "upstream-mman.patch" to fix include "sys/mman.h".
      Thanks, Piotr Sarna.
    + Added "build-hurd.patch" with PATH_MAX definition.
  * Master: install "globaliolimits.cfg.5".
  * Systemd:
    + start chunkserver after master (otherwise chunkserver may fail).
    + added chunkserver suspend handlers for pm-suspend and systemd.
  * Lintianisation:
    + command-with-path-in-maintainer-script
  * Build-Depends: versioned dependency "libfuse-dev (>= 2.9.0)"
    because of FTBFS on GNU Hurd due to outdated libfuse.
  * Add "-latomic" to LFDLAGS on [mips,mipsel,sparc] to fix FTBFS.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 28 Jun 2015 16:29:19 +1000

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
 
 ## fix FTBFS@ppc64: https://github.com/lizardfs/lizardfs/issues/249
-ifneq (,$(filter $(DEB_HOST_ARCH),powerpc powerpcspe))
+ifneq (,$(filter $(DEB_HOST_ARCH),mips mipsel powerpc powerpcspe sparc))
 DEB_LDFLAGS_MAINT_APPEND = -latomic
 endif
 
@@ -30,16 +30,17 @@
 	## copy gtest sources
 	cp -Rv /usr/src/gtest external/
 	dh_auto_configure -- $(OPTARGS)    \
-               -DCMAKE_VERBOSE_MAKEFILE=ON \
-               -DCMAKE_BUILD_TYPE=Release  \
-               -DCMAKE_INSTALL_PREFIX=""   \
-               -DENABLE_DEBIAN_PATHS=YES   \
+               -DCMAKE_BUILD_TYPE=Release   \
+               -DCMAKE_INSTALL_PREFIX="/"   \
+               -DCMAKE_VERBOSE_MAKEFILE=ON  \
+               -DENABLE_VERBOSE_ASCIIDOC=ON \
+               -DENABLE_DEBIAN_PATHS=YES    \
                -DENABLE_UTILS=YES
 
 override_dh_auto_install:
 	dh_auto_install
 	## rename config files
-	for i in debian/tmp/etc/mfs/*.cfg.dist; do \
+	for i in debian/tmp/etc/lizardfs/*.cfg.dist; do \
 	    mv -n -v "$$i" "$${i%%.dist}"          \
 	;done

=== debian/watch ===
# uscan(1) configuration file.
version=3

opts=\
repacksuffix=+dfsg,\
dversionmangle=s{\+dfsg\d*}{},\
uversionmangle=s{\-(\d+)\Z}{.$1},\
 https://github.com/lizardfs/lizardfs/releases \
 .*/archive/v?(\d[-\d\.]+)\.tar\.gz

## lizardfs 3.9.4%2Bdfsg

=== src/admin/CMakeLists.txt ===
collect_sources(LIZARDFS_ADMIN)

add_library(lizardfs-admin-lib ${LIZARDFS_ADMIN_SOURCES})
target_link_libraries(lizardfs-admin-lib mfscommon)
add_tests(lizardfs-admin-lib ${LIZARDFS_ADMIN_TESTS})

add_executable(lizardfs-admin ${LIZARDFS_ADMIN_MAIN})
target_link_libraries(lizardfs-admin lizardfs-admin-lib)
install(TARGETS lizardfs-admin RUNTIME DESTINATION ${BIN_SUBDIR})

add_custom_target(lizardfs-probe ALL
    COMMAND ln -sf lizardfs-admin lizardfs-probe
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS lizardfs-admin)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lizardfs-probe DESTINATION ${BIN_SUBDIR})

=== src/common/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

collect_sources(COMMON)

if(MINGW)
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/lockfile.cc")
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/metadata.cc")
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/setup.cc")
endif()

add_library(mfscommon ${COMMON_SOURCES})
if (HAVE_CRCUTIL)
  # Use crcutil Library
  include_directories(${CRCUTIL_INCLUDE_DIRS})
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CRCUTIL_CXX_FLAGS}")
  target_link_libraries(mfscommon ${CRCUTIL_LIBRARIES})
endif()
if (ZLIB_FOUND)
  target_link_libraries(mfscommon ${ZLIB_LIBRARIES})
endif()
if (RT_LIBRARY)
  target_link_libraries(mfscommon ${RT_LIBRARY})
endif()
if(TCMALLOC_LIBRARY)
  target_link_libraries(mfscommon ${TCMALLOC_LIBRARY})
endif()
if(SOCKET_FOUND)
  target_link_libraries(mfscommon ${SOCKET_LIBRARIES})
endif()
if(MINGW)
  target_link_libraries(mfscommon ${MINGW_MSVCRT})
endif()

add_tests(mfscommon ${COMMON_TESTS})

=== src/metarestore/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR} ../master)
add_definitions(-DMETARESTORE)
add_definitions(-DAPPNAME=mfsmetarestore)

collect_sources(METARESTORE)

file(GLOB METARESTORE_MASTER_SOURCES ../master/filesystem*.cc)

add_library(metarestore ${METARESTORE_SOURCES} ${METARESTORE_MASTER_SOURCES} ../master/chunks.cc ../master/quota_database.cc ../master/chunk_goal_counters.cc ../master/restore.cc ../master/locks.cc)
target_link_libraries(metarestore mfscommon)
if(JUDY_LIBRARY)
  target_link_libraries(metarestore ${JUDY_LIBRARY})
endif()
add_tests(metarestore ${METARESTORE_TESTS})

add_executable(mfsmetarestore ${METARESTORE_MAIN})
target_link_libraries(mfsmetarestore metarestore mfscommon ${PAM_LIBRARIES})
install(TARGETS mfsmetarestore RUNTIME DESTINATION ${SBIN_SUBDIR})

=== src/mount/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

collect_sources(MOUNT)

add_library(mount ${MOUNT_SOURCES})
target_link_libraries(mount mfscommon ${ADDITIONAL_LIBS})
if(MINGW)
  target_link_libraries(mount ${MINGW_MSVCRT})
endif()

add_tests(mount ${MOUNT_TESTS})

install(PROGRAMS mfssnapshot DESTINATION ${BIN_SUBDIR})

=== src/devtools/mycrc32/CMakeLists.txt ===
aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR} MYCRC32_SOURCES)
add_executable(mycrc32 ${MYCRC32_SOURCES})
target_link_libraries(mycrc32 mfscommon)
